<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */

# Funciones varias
# Dominio pblico. 2005. vtamara@pasosdejesus.org
 
function escape($v) {
	if ($v==null) {
		return '';
	}
	else if (is_array($v)) {
		$r=array();
		foreach($v as $i => $e) {
			$r[$i]=escape($e);
		}
		return $r;
	}
	else {
		return str_replace('\'', '\\\'', $v);
	}
}

function encabezado($t) {
	echo "<html>\n";
	echo "<head><title>$t</title></head>\n";
	echo "<body bgcolor=\"#FFFFFF\">\n";
	echo "<h2>$t</h2>";
}

function pie() {
	echo "</body>";
	echo "</html>";
}

/** Valida datos recibidos por formulario y llena variables.
    @param prof Si es null llena hasta ah
    @param salon Si es null llena hasta ah
    @param carga Si es null llena hasta ah
    @param fija Si es null llena hasta ah
*/
function valida(&$profesores, &$horas, &$salones, &$prof,
	&$hora, &$salon, &$carga, &$fija)
{

	$horas=(int)escape($_POST['horas']);
	$salones=(int)escape($_POST['salones']);
	$profesores=(int)escape($_POST['profesores']);
	if ($horas<=0 || $horas>24) {
	    die("Horas debe estar entre 1 y 24");
	}
	if ($profesores<=0 || $profesores>30) {
	    die("Profesores debe estar entre 1 y 30");
	}
	if ($salones<=0 || $salones>30) {
		die("Salones debe estar entre 1 y 30");
	}

    if ($prof===null) {
        return ;
    }
	$prof=array();
	for($i=0; $i<$profesores; $i++) {
	    $prof[$i]=escape($_POST["p$i"]);
        if ($prof[$i]=='' || strlen($prof[$i])>15) {
            die("La etiqueta del $i-esimo profesor debe tener entre 1 y 15 caracteres");
        }
    }
    if ($hora===null) {
        return ;
    }
    $hora=array();
    for($i=0; $i<$horas; $i++) {
	    $hora[$i]=escape($_POST["h$i"]);
    	if ($hora[$i]=='' || strlen($hora[$i])>15) {
    		die("La etiqueta de la $i-esima hora debe tener entre 1 y 15 caracteres");
    	}
    }
    if ($salon===null) {
        return ;
    }
    $salon=array();
    for($i=0; $i<$salones; $i++) {
    	$sv[$i]=0;  // Suma vertical
    	$salon[$i]=escape($_POST["s$i"]);
    	if ($salon[$i]=='' || strlen($salon[$i])>15) {
    		die("La etiqueta de la $i-esima hora debe tener entre 1 y 15 caracteres");
    	}
    }
    if ($carga===null) {
        return ;
    }
    $carga=array();
    for($p=0; $p<$profesores; $p++) {
    	$sh=0;
    	for($s=0; $s<$salones; $s++) {
    		$carga[$p][$s]=(int)escape($_POST["c-$p-$s"]);
    		if ($carga[$p][$s]<0 || $carga[$p][$s]>$horas) {
    			die("La carga del profesor $p (".
    					$prof[$p].") en el saln $ (".
    					$salon[$s].") debe estar entre 0 y $horas");
    		}
    		$sh+=$carga[$p][$s];
    		$sv[$s]+=$carga[$p][$s];
    	}
    	if ($sh>$horas) {
    		die("La carga total (suma horizontal) del profesor $i (".
    				$prof[$p].")  debera ser menor o igual a $horas.");
        }
    }
    for($s=0; $s<$salones; $s++) {
    	if ($sv[$s]!=$horas) {
    		die("La carga total (suma vertical) en el salon $i (".
    			$salon[$s].") debera ser $horas.");
    	}
    }
    if ($fija===null) {
        return ;
    }
    $fija=array();
    for($s=0; $s<$salones; $s++) {
        $cs=array(); // Horas fijas de profesores en salon $s
        for($h=0; $h<$horas; $h++) {
            if (isset($_POST["f-$s-$h"]) && 
                $_POST["f-$s-$h"]!='' && $_POST["f-$s-$h"]!='-1') {
    		    $p=$fija[$s][$h]=(int)escape($_POST["f-$s-$h"]);
                if (!isset($cs[$p])) {
                    $cs[$p]=1;
                }
                else {
                    $cs[$p]++;
                }
                if ($p<0 || $p>$profesores) {
                    die("Profesor desconocido (".$p.") ".
                        " en el salon $s (".$salon[$s].") a la hora $h (".
                        $hora[$h].")");
                }
                for ($s2=0; $s2<$s; $s2++) {
                    if ($fija[$s2][$h]==$p) {
                        die("Profesor $p (".$prof[$p].") ya est asignado a ".
                            "la hora $h (".$hora[$h].") en el salon $s (".
                            $salon[$s].")");
                    }
                }
            }
            else {
                $fija[$s][$h]=-1;
            }
        }
        foreach($cs as $p => $hs) {
            if ($hs>$carga[$p][$s]) {
                die("Se fijaron $hs horas del profesor $p (".
                    $prof[$p].") en el salon $s (".
                    $salon[$s]."), pero la carga era slo ".$carga[$p][$s]);
            }
        }
    }
}

function escondidos($profesores, $horas, $salones, 
    $prof=null, $hora=null, $salon=null, $carga=null, $fija=null) 
{
    echo "<input type=\"hidden\" name=\"profesores\" value=\"$profesores\"/>\n";
    echo "<input type=\"hidden\" name=\"horas\" value=\"$horas\"/>\n";
    echo "<input type=\"hidden\" name=\"salones\" value=\"$salones\"/>\n";
    if ($prof==null) {
        return;
    }
    for($i=0; $i<$profesores; $i++) {
    	echo "<input type=\"hidden\" name=\"p$i\" value=\"".
    		$prof[$i]."\"/>\n";
    }
    if ($hora==null) {
        return;
    }
    for($i=0; $i<$horas; $i++) {
    	echo "<input type=\"hidden\" name=\"h$i\" value=\"".
    		$hora[$i]."\"/>\n";
    }
    if ($salon==null) {
        return;
    }
    for($i=0; $i<$salones; $i++) {
    	echo "<input type=\"hidden\" name=\"s$i\" value=\"".
    		$salon[$i]."\"/>\n";
    }
    if ($carga==null) {
        return;
    }
    for($p=0; $p<$profesores; $p++) {
    	for($s=0; $s<$salones; $s++) {
    		echo "<input type=\"hidden\" name=\"c-$p-$s\" value=\"".
    			$carga[$p][$s]."\"/>\n";
    	}
    }

    if ($fija==null) {
        return;
    }
    for($s=0; $s<$salones; $s++) {
        for($h=0; $h<$horas; $h++) {
    		echo "<input type=\"hidden\" name=\"f-$s-$h\" value=\"".
    			$fija[$s][$h]."\"/>\n";
    	}
    }
}

?>
